Debian Bug report logs - #682574
live-tools, procps: live-tools and procps must consistently handle /usr/bin/uptime

version graph

Packages: procps, live-tools; Maintainer for procps is Craig Small <csmall@debian.org>; Source for procps is src:procps. Maintainer for live-tools is Live Systems Maintainers <debian-live@lists.debian.org>; Source for live-tools is src:live-tools.

Reported by: Andreas Beckmann <debian@abeckmann.de>

Date: Mon, 23 Jul 2012 20:21:01 UTC

Severity: serious

Found in versions procps/1:3.3.3-2, live-tools/3.0.3-1, live-tools/3.0.4-1

Fixed in version live-tools/3.0.6-1

Done: Daniel Baumann <daniel@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Debian Live Project <debian-live@lists.debian.org>, Craig Small <csmall@debian.org>:
Bug#682574; Package live-tools,procps. (Mon, 23 Jul 2012 20:21:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Andreas Beckmann <debian@abeckmann.de>:
New Bug report received and forwarded. Copy sent to Debian Live Project <debian-live@lists.debian.org>, Craig Small <csmall@debian.org>. (Mon, 23 Jul 2012 20:21:04 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Andreas Beckmann <debian@abeckmann.de>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: live-tools, procps: live-tools and procps must consistently handle /usr/bin/uptime
Date: Mon, 23 Jul 2012 22:18:28 +0200
Package: live-tools,procps
Severity: serious

Hi,

live-utils (3.0.3-1)
* diverts /usr/bin/uptime to /usr/bin/uptime.procps
* does not divert uptime.1.gz
* ships /usr/bin/uptime -> live-uptime

procps (1:3.3.3-2)
* ships /usr/bin/uptime
* ships uptime.1.gz
* installs an alternative for uptime if /usr/bin/uptime.procps exists
  with a corresponding slave alternative for uptime.1.gz

Depending on the installation order you get:
* procps, live-utils
  /usr/bin/utime -> live-uptime
* live-utils, procps
  /usr/bin/utime -> /etc/alternatives/uptime -> /usr/bin/uptime.procps
  (yes, the alternative will overwrite the link shipped by live-tools)

Depending on the install and remove order, you may end up with a
dangling symlink /usr/bin/utime and a forgotten alternative.

Mixing diversions and alternatives is not trivial ... I know from
cleaning up the nvidia-graphics-driver and fglrx-driver diversion mess
for /usr/lib/libGL.so* :-)


A possible solution that should work:
* procps ships uptime.procps and uptime.procps.1.gz
* live-utils ships live-uptime and live-uptime.1.gz
* both register an alternative for uptime with uptime.1.gz slave

For a clean upgrade path from the current mess to a working uptime ...
propably just for both procps.preinst and live-tools.postinst:
  if [ "$(dpkg-divert --listpackage /usr/bin/uptime)" = "live-tools" ]
  then
    # no --rename !
    dpkg-divert --remove --package live-tools --divert \
        /usr/bin/uptime.procps /usr/bin/uptime
  fi

Ask me if you need help getting this cleaned up.


Andreas



Marked as found in versions live-utils/3.0.3-1. Request was from Andreas Beckmann <debian@abeckmann.de> to control@bugs.debian.org. (Mon, 23 Jul 2012 20:48:05 GMT) Full text and rfc822 format available.

Marked as found in versions procps/1:3.3.3-2. Request was from Andreas Beckmann <debian@abeckmann.de> to control@bugs.debian.org. (Mon, 23 Jul 2012 20:48:06 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Live Project <debian-live@lists.debian.org>:
Bug#682574; Package live-tools,procps. (Mon, 23 Jul 2012 23:27:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Craig Small <csmall@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Live Project <debian-live@lists.debian.org>. (Mon, 23 Jul 2012 23:27:03 GMT) Full text and rfc822 format available.

Message #14 received at 682574@bugs.debian.org (full text, mbox):

From: Craig Small <csmall@debian.org>
To: Andreas Beckmann <debian@abeckmann.de>, 682574@bugs.debian.org
Subject: Re: Bug#682574: live-tools, procps: live-tools and procps must consistently handle /usr/bin/uptime
Date: Tue, 24 Jul 2012 09:16:49 +1000
On Mon, Jul 23, 2012 at 10:18:28PM +0200, Andreas Beckmann wrote:
> Mixing diversions and alternatives is not trivial ... I know from
> cleaning up the nvidia-graphics-driver and fglrx-driver diversion mess
> for /usr/lib/libGL.so* :-)
I believe there is also something about packages diverting others
letting the first one know about it, which didn't happen and probably
contributed to the mess.

> A possible solution that should work:
> * procps ships uptime.procps and uptime.procps.1.gz
> * live-utils ships live-uptime and live-uptime.1.gz
> * both register an alternative for uptime with uptime.1.gz slave
Yep, would of done it had I known about it, I'll update procps with
this and the fix below, thanks!

And yes I traced through the fglrx symlink stuff once, it was
complicated but generally worked ok (except when non-free binaries
hard-coded the wrong stuff but thats another story).

 - Craig
-- 
Craig Small VK2XLZ   http://enc.com.au/          csmall at : enc.com.au
Debian GNU/Linux     http://www.debian.org/      csmall at : debian.org
GPG fingerprint:     5D2F B320 B825 D939 04D2  0519 3938 F96B DF50 FEA5



Information forwarded to debian-bugs-dist@lists.debian.org, Debian Live Project <debian-live@lists.debian.org>, Craig Small <csmall@debian.org>:
Bug#682574; Package live-tools,procps. (Tue, 24 Jul 2012 05:42:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to daniel.baumann@progress-technologies.net:
Extra info received and forwarded to list. Copy sent to Debian Live Project <debian-live@lists.debian.org>, Craig Small <csmall@debian.org>. (Tue, 24 Jul 2012 05:42:03 GMT) Full text and rfc822 format available.

Message #19 received at 682574@bugs.debian.org (full text, mbox):

From: Daniel Baumann <daniel.baumann@progress-technologies.net>
To: Craig Small <csmall@debian.org>
Cc: 682574@bugs.debian.org
Subject: Re: Bug#682574: live-tools, procps: live-tools and procps must consistently handle /usr/bin/uptime
Date: Tue, 24 Jul 2012 07:33:41 +0200
On 07/24/2012 01:16 AM, Craig Small wrote:
>> A possible solution that should work:
>> * procps ships uptime.procps and uptime.procps.1.gz
>> * live-utils ships live-uptime and live-uptime.1.gz
>> * both register an alternative for uptime with uptime.1.gz slave
> Yep, would of done it had I known about it, I'll update procps with
> this and the fix below, thanks!

no, don't do that, it's overkill.

live-tools should for the time being contains a 'fix' for uptime to be
usefull within lxc containers (don't ask why this is in a package called
live-*, that's another sad story), once that's not necessary anymore
because upstream handels that, we can just remove it.

i'll add a divertion for the manpage too, (which is pretty pointless,
saying it's a divertion and that everything in the 'original' manpage
applies, but anyway...), procps should not be changed in anyway wrt/
this bug.

-- 
Address:        Daniel Baumann, Donnerbuehlweg 3, CH-3012 Bern
Email:          daniel.baumann@progress-technologies.net
Internet:       http://people.progress-technologies.net/~daniel.baumann/



Reply sent to Daniel Baumann <daniel@debian.org>:
You have taken responsibility. (Wed, 25 Jul 2012 14:51:06 GMT) Full text and rfc822 format available.

Notification sent to Andreas Beckmann <debian@abeckmann.de>:
Bug acknowledged by developer. (Wed, 25 Jul 2012 14:51:06 GMT) Full text and rfc822 format available.

Message #24 received at 682574-close@bugs.debian.org (full text, mbox):

From: Daniel Baumann <daniel@debian.org>
To: 682574-close@bugs.debian.org
Subject: Bug#682574: fixed in live-tools 3.0.4-1
Date: Wed, 25 Jul 2012 14:47:11 +0000
Source: live-tools
Source-Version: 3.0.4-1

We believe that the bug you reported is fixed in the latest version of
live-tools, which is due to be installed in the Debian FTP archive.

A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 682574@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Daniel Baumann <daniel@debian.org> (supplier of updated live-tools package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.8
Date: Tue, 24 Jul 2012 21:43:48 +0200
Source: live-tools
Binary: live-tools
Architecture: source all
Version: 3.0.4-1
Distribution: unstable
Urgency: low
Maintainer: Debian Live Project <debian-live@lists.debian.org>
Changed-By: Daniel Baumann <daniel@debian.org>
Description: 
 live-tools - Debian Live - System Support Scripts
Closes: 682574
Changes: 
 live-tools (3.0.4-1) unstable; urgency=low
 .
   * Using common source tree layout for all live packages.
   * Completing uninstall target in toplevel Makefile.
   * Unifying copyright headers to use same GPL blurbs.
   * Adding reference to live-debconfig in live-config manpage.
   * Using dynamic year in automatic manpage date translation rather than
     a hardcoded one.
   * Moving executables from /usr/bin to /bin as they potentially need to
     be arround before /usr is available.
   * Also diverting uptime manpage from procps (Closes: #682574).
Checksums-Sha1: 
 432528b458d784d80074de1c9c65a2e516ed574b 1259 live-tools_3.0.4-1.dsc
 89b20a264c8edf52c55c53fbac36826adcff7221 16724 live-tools_3.0.4.orig.tar.xz
 53a46740c142e430dce30cd569b610fe90ba48d9 3532 live-tools_3.0.4-1.debian.tar.xz
 97d15489df6899d4acb86ff0af56c3cd8725574d 7918 live-tools_3.0.4-1_all.deb
Checksums-Sha256: 
 a7a7ba1d609db5b0bbde97ca44e74b190015b00eb9aff63e404c7b320ec5a61a 1259 live-tools_3.0.4-1.dsc
 ed29de7364b7f7e4d467a3a4c8f42cfc105833877548c1855a5b8d8e4f0b92dd 16724 live-tools_3.0.4.orig.tar.xz
 015417e5d5b90141679b15bfd13d6d70a0a0e19182958af523f6b31dad7bd469 3532 live-tools_3.0.4-1.debian.tar.xz
 925d3b22d34ca291fbb64947b51e91ec084ccbc43a0b892b5568d4ca9e59dfe9 7918 live-tools_3.0.4-1_all.deb
Files: 
 5d54a3ab41cbcf725ed741ef37183dd9 1259 misc optional live-tools_3.0.4-1.dsc
 32025d690f4812ea84160a6e191aae10 16724 misc optional live-tools_3.0.4.orig.tar.xz
 034bfeda6c2baefab4629aa3082903ea 3532 misc optional live-tools_3.0.4-1.debian.tar.xz
 b931a29bbcb7c5843133a1e7c32da6bf 7918 misc optional live-tools_3.0.4-1_all.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.10 (GNU/Linux)

iEYEARECAAYFAlAP+YMACgkQ+C5cwEsrK56liwCgsbyXhaJXg0Ua9G6WeKr+M8x3
ewoAn0Ag0He9ivnU62AqT1vJfBQ3rbHm
=S6rZ
-----END PGP SIGNATURE-----




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Live Project <debian-live@lists.debian.org>, Craig Small <csmall@debian.org>:
Bug#682574; Package live-tools,procps. (Sat, 04 Aug 2012 11:09:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Andreas Beckmann <debian@abeckmann.de>:
Extra info received and forwarded to list. Copy sent to Debian Live Project <debian-live@lists.debian.org>, Craig Small <csmall@debian.org>. (Sat, 04 Aug 2012 11:09:03 GMT) Full text and rfc822 format available.

Message #29 received at 682574@bugs.debian.org (full text, mbox):

From: Andreas Beckmann <debian@abeckmann.de>
To: 682574@bugs.debian.org
Cc: control@bugs.debian.org
Subject: Re: Bug#682574 closed by Daniel Baumann <daniel@debian.org> (Bug#682574: fixed in live-tools 3.0.4-1)
Date: Sat, 04 Aug 2012 13:04:40 +0200
found 682574 3.0.4-1
thanks

On 2012-07-25 16:51, Debian Bug Tracking System wrote:
>    * Also diverting uptime manpage from procps (Closes: #682574).

That only fixes a minor issue. The big problem stays:

> Depending on the installation order you get:
> * procps, live-utils
>   /usr/bin/utime -> live-uptime
> * live-utils, procps
>   /usr/bin/utime -> /etc/alternatives/uptime -> /usr/bin/uptime.procps
>   (yes, the alternative will overwrite the link shipped by live-tools)
> 
> Depending on the install and remove order, you may end up with a
> dangling symlink /usr/bin/utime and a forgotten alternative.

Since procps is aware of possibly being diverted, this cannot be fixed
in live-tools alone.

Daniel Baumann wrote:
> On 07/24/2012 01:16 AM, Craig Small wrote:
>>> * both register an alternative for uptime with uptime.1.gz slave
>> Yep, would of done it had I known about it, I'll update procps with
>> this and the fix below, thanks!
>
> no, don't do that, it's overkill.
> 
> live-tools should for the time being contains a 'fix' for uptime to be
> usefull within lxc containers (don't ask why this is in a package called
> live-*, that's another sad story), once that's not necessary anymore
> because upstream handels that, we can just remove it.

Why can't the fix be applied to the uptime command in procps? That would
avoid duplicating uptime and the diversions at all ...


Andreas



Marked as found in versions live-tools/3.0.4-1; no longer marked as fixed in versions live-tools/3.0.4-1 and reopened. Request was from Andreas Beckmann <debian@abeckmann.de> to control@bugs.debian.org. (Sat, 04 Aug 2012 11:09:07 GMT) Full text and rfc822 format available.

Reply sent to Daniel Baumann <daniel@debian.org>:
You have taken responsibility. (Sat, 04 Aug 2012 15:24:04 GMT) Full text and rfc822 format available.

Notification sent to Andreas Beckmann <debian@abeckmann.de>:
Bug acknowledged by developer. (Sat, 04 Aug 2012 15:24:04 GMT) Full text and rfc822 format available.

Message #36 received at 682574-close@bugs.debian.org (full text, mbox):

From: Daniel Baumann <daniel@debian.org>
To: 682574-close@bugs.debian.org
Subject: Bug#682574: fixed in live-tools 3.0.6-1
Date: Sat, 04 Aug 2012 15:20:16 +0000
Source: live-tools
Source-Version: 3.0.6-1

We believe that the bug you reported is fixed in the latest version of
live-tools, which is due to be installed in the Debian FTP archive.

A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 682574@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Daniel Baumann <daniel@debian.org> (supplier of updated live-tools package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.8
Date: Sat, 04 Aug 2012 15:46:46 +0200
Source: live-tools
Binary: live-tools
Architecture: source all
Version: 3.0.6-1
Distribution: unstable
Urgency: low
Maintainer: Debian Live Project <debian-live@lists.debian.org>
Changed-By: Daniel Baumann <daniel@debian.org>
Description: 
 live-tools - Debian Live - System Support Scripts
Closes: 682574
Changes: 
 live-tools (3.0.6-1) unstable; urgency=low
 .
   * Adding pre-depends to procps and initramfs-tools (Closes: #682574).
Checksums-Sha1: 
 36ec217108be61792806ba76b0a4747871a316f5 1259 live-tools_3.0.6-1.dsc
 2fd78771255bc44c6ba6ae600875cf249a5f0403 19080 live-tools_3.0.6.orig.tar.xz
 7fa8187f0d4e131a62e65df106a787a24c8e6a0d 3792 live-tools_3.0.6-1.debian.tar.xz
 78280811191f9e566912d7c5263c2a43447c02ab 11756 live-tools_3.0.6-1_all.deb
Checksums-Sha256: 
 b7dcf926616370f4d93afffffaabce334672eb3c4e0c145be1e6029bcc79aa96 1259 live-tools_3.0.6-1.dsc
 1bf27098d8ccf4d0cf19aab81b70045717cfe190cb8872329f1781ecf57b47f9 19080 live-tools_3.0.6.orig.tar.xz
 3c238e88dea3e65a05eb3f22ca05fa42616ecd6e6b091da73efdbabdec6e3b82 3792 live-tools_3.0.6-1.debian.tar.xz
 7734b538fc178156faf120fd9ebe97c0a93b6aef91e56b9f3a9286d454cac58e 11756 live-tools_3.0.6-1_all.deb
Files: 
 4eca9d29f15c504fce27e9cc69a58fa5 1259 misc optional live-tools_3.0.6-1.dsc
 df002d32d47776080a95891c5650af32 19080 misc optional live-tools_3.0.6.orig.tar.xz
 fda4921723f4d3ec08fc18b55af12cde 3792 misc optional live-tools_3.0.6-1.debian.tar.xz
 7facac8f3906c8f61a2103df214aa4a6 11756 misc optional live-tools_3.0.6-1_all.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.10 (GNU/Linux)

iEYEARECAAYFAlAdKDIACgkQ+C5cwEsrK554NACfTA7akwVniZyHZqnAv/+3Z8kl
5Q8AnAy6nAg+vq38bWiedLRtLIJeMDRF
=Chuh
-----END PGP SIGNATURE-----




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Live Project <debian-live@lists.debian.org>, Craig Small <csmall@debian.org>:
Bug#682574; Package live-tools,procps. (Sat, 04 Aug 2012 15:30:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Andreas Beckmann <debian@abeckmann.de>:
Extra info received and forwarded to list. Copy sent to Debian Live Project <debian-live@lists.debian.org>, Craig Small <csmall@debian.org>. (Sat, 04 Aug 2012 15:30:05 GMT) Full text and rfc822 format available.

Message #41 received at 682574@bugs.debian.org (full text, mbox):

From: Andreas Beckmann <debian@abeckmann.de>
To: 682574@bugs.debian.org
Subject: Re: Bug#682574 closed by Daniel Baumann <daniel@debian.org> (Bug#682574: fixed in live-tools 3.0.6-1)
Date: Sat, 04 Aug 2012 17:27:56 +0200
On 2012-08-04 17:24, Debian Bug Tracking System wrote:
>   * Adding pre-depends to procps and initramfs-tools (Closes: #682574).

That will work for the initial installation, but breaks if procps is
upgraded/reinstalled later on.


Andreas



Information forwarded to debian-bugs-dist@lists.debian.org, Debian Live Project <debian-live@lists.debian.org>, Craig Small <csmall@debian.org>:
Bug#682574; Package live-tools,procps. (Fri, 10 Aug 2012 13:12:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Evgeni Golov <evgeni@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Live Project <debian-live@lists.debian.org>, Craig Small <csmall@debian.org>. (Fri, 10 Aug 2012 13:12:03 GMT) Full text and rfc822 format available.

Message #46 received at 682574@bugs.debian.org (full text, mbox):

From: Evgeni Golov <evgeni@debian.org>
To: Andreas Beckmann <debian@abeckmann.de>, 682574@bugs.debian.org
Subject: Re: tagging 672870, tagging 664261, tagging 682382, tagging 682499, found 682574 in live-utils/3.0.3-1 ...
Date: Fri, 10 Aug 2012 15:09:38 +0200
On Mon, Jul 23, 2012 at 10:45:30PM +0200, Andreas Beckmann wrote:
> found 682574 live-utils/3.0.3-1

You surely meant live-tools/3.0.3-1 here, right?
Which makes live-tools/3.0.3-1 in Wheezy RC-buggy?

-- 
Bruce Schneier can read and understand Perl programs.



Marked as found in versions live-tools/3.0.3-1. Request was from Andreas Beckmann <debian@abeckmann.de> to control@bugs.debian.org. (Mon, 13 Aug 2012 15:51:06 GMT) Full text and rfc822 format available.

No longer marked as found in versions live-utils/3.0.3-1. Request was from Andreas Beckmann <debian@abeckmann.de> to control@bugs.debian.org. (Mon, 13 Aug 2012 15:51:06 GMT) Full text and rfc822 format available.

Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Tue, 11 Sep 2012 07:30:27 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Sun Apr 20 12:03:17 2014; Machine Name: beach.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.